{#-#####################################################################
 # Jinja2 template for /etc/rc.conf.d/netif
 #======================================================================
 # Helper macros for the FreeBSD rc network framework
 ####################################################################-#}
{#======================================================================
 # format_rc_var
 #----------------------------------------------------------------------
 #
 # This macro is responsible for rendering a single rc variable using
 # the constraints common to the rc.conf file format.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - name (str)
 #      Name or the rc variable to render
 #
 #  - value (str or str[])
 #      Value of the rc variable to render. If a list is supplied, each
 #      list item shall be rendered on a single line, with automatic
 #      escaping.
 #
 #  - comment (str, optional)
 #      Optional comment to show above rendered lines.
 #===================================================================-#}
{%- macro format_rc_var(name, value, comment=None) -%}
  {%- if name and value and (value is string or value is iterable) -%}

    {%- if comment -%}
      {{ "# " ~ comment ~ "\n" }}
    {%- endif -%}

    {{ name ~ "=" }}

    {%- if value is string -%}
      {{ '"' ~ value ~ '"' ~ "\n" }}
    {%- elif value is iterable -%}
      {{ '"\\\n\t' ~ value | join(" \\\n\t") ~ '"' ~ "\n" }}
    {%- endif -%}

  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # render_cloned_interfaces
 #----------------------------------------------------------------------
 #
 # This macro generates and echoes the 'cloned_interfaces' rc variable.
 # The variable is built directly from the content of the
 # ``my_network_interfaces`` inventory variable.
 #
 # Note that we use the ``cloned_interfaces`` variable to create 'vlan'
 # interfaces instead of ``vlans_x`` variables because it's far easier
 # to handle in Jinja (``vlans_x`` require that we build the full list
 # of all child vLANs for each interface, which is quite tedious).
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #
 # None
 #
 #===================================================================-#}
{%- macro render_cloned_interfaces() -%}
  {%- set cloned_interfaces = [] -%}

  {%- for interface in my_network_interfaces -%}
    {%- if interface['type'] in ['bond', 'bridge', 'vlan'] -%}
      {%- set native_name =
            common.get_interface_name(interface, true) -%}
      {{ cloned_interfaces.append(native_name) }}
    {%- endif -%}
  {%- endfor -%}

  {%- if cloned_interfaces -%}
    {{
      format_rc_var('cloned_interfaces', cloned_interfaces | join(" "))
    }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Render create_args_x
 #----------------------------------------------------------------------
 #
 # This macro generates and echoes the 'create_args_x' rc variable for
 # the supplied virtual interface.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro render_create_args_x(interface) -%}
  {%- set args = [] -%}

  {#--------------------------------------------------------------------
   # Bond interfaces
   #------------------------------------------------------------------#}
  {%- if interface['type'] == 'bond' -%}
    {#- LAGG protocol -#}
    {%- set laggproto = ifconfig.get_laggproto(interface) -%}
    {%- if laggproto -%}
      {{ args.append('laggproto ' ~ laggproto) }}
    {%- endif -%}

    {#- LAGG hash policy -#}
    {%- set lagghash = ifconfig.get_lagghash(interface) -%}
    {%- if lagghash -%}
      {{ args.append('lagghash ' ~ lagghash) }}
    {%- endif -%}

    {#- LAGG ports -#}
    {%- set laggports =
          common.get_interface_names_from_list(
            interface['bond']['members'], true)
          | from_json
    -%}
    {%- for laggport in laggports -%}
      {{ args.append('laggport ' ~ laggport) }}
    {%- endfor -%}

  {#--------------------------------------------------------------------
   # Bridge interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'bridge' -%}

    {#- Check whether STP is enabled on the bridge interface -#}
    {%- set bridge_stp_is_enabled = false -%}
    {%- if  'bridge' in interface
        and 'stp' in interface['bridge']
        and 'enabled' in interface['bridge']['stp']
    -%}
      {%- if interface['bridge']['stp']['enabled'] -%}
        {%- set bridge_stp_is_enabled = true -%}
      {%- endif -%}
    {%- endif -%}
    
    {#- Bridge members -#}
    {%- set bridge_member_names =
        common.get_interface_names_from_list(
          interface['bridge']['members'], true)
        | from_json
    -%}
    {%- for bridge_member_name in bridge_member_names -%}
      {{ args.append('addm ' ~ bridge_member_name) }}
      {#- Per-member STP options -#}
      {%- if bridge_stp_is_enabled -%}
        {{ args.append('stp') }}
      {%- else -%}
        {{ args.append('-stp') }}
      {%- endif -%}
    {%- endfor -%}

    {#- Bridge-wide STP options -#}
    {%- if bridge_member_name -%}

      {#- Forwarding delay -#}
      {%- if 'delay' in interface['bridge']['stp'] -%}
        {{
          args.append(
            'fwddelay ' ~ interface['bridge']['stp']['delay'] | int)
        }}
      {%- endif -%}

      {#- Hello time -#}
      {%- if 'hello_time' in interface['bridge']['stp'] -%}
        {{
          args.append(
            'hellotime ' ~
            interface['bridge']['stp']['hello_time'] | int)
        }}
      {%- endif -%}

      {#- Priority -#}
      {%- if 'priority' in interface['bridge']['stp'] -%}
        {{
          args.append(
            'priority ' ~ interface['bridge']['stp']['priority'] | int)
        }}
      {%- endif -%}

      {#- Protocol variant -#}
      {%- if 'variant' in interface['bridge']['stp'] -%}
        {%-   if interface['bridge']['stp']['variant'] == "classic" -%}
          {{ args.append('proto stp') }}
        {%- elif interface['bridge']['stp']['variant'] == "rapid" -%}
          {{ args.append('proto rstp') }}
        {%- endif -%}
      {%- endif -%}

    {%- endif -%}

  {#--------------------------------------------------------------------
   # vLAN interfaces
   #------------------------------------------------------------------#}
  {%- elif interface['type'] == 'vlan' -%}
    {#- vLAN ID -#}
    {{ args.append('vlan ' ~ interface['vlan']['index'] | int) }}

    {#- vLAN parent device -#}
    {%- set parent_interface_name =
        common.get_interface_name(interface['vlan']['parent'], true) -%}
    {{ args.append('vlandev ' ~ parent_interface_name) }}
  {%- endif -%}

  {#--------------------------------------------------------------------
   # Render the RC variable
   #------------------------------------------------------------------#}
  {%- set interface_name = common.get_interface_name(interface, true)-%}
  {%- if args -%}
    {%- set variable_name = 'create_args_' ~ interface_name -%}
    {{ format_rc_var(variable_name, args | join(" ")) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # render_ifconfig_x
 #----------------------------------------------------------------------
 #
 # This macro is responsible for generating and echoing the main
 # ifconfig_x rc variable for the supplied interface.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro render_ifconfig_x(interface) -%}
  {#- ifconfig segments are stored in this buffer list -#}
  {%- set segments = [] -%}

  {#- ifconfig keywords must come before anything else -#}
  {%- set keywords =
      ifconfig.get_keywords(interface) | from_json -%}
  {%- if keywords -%}
    {{ segments.append(keywords | join(" ")) }}
  {%- endif -%}

  {#- ifconfig link options must come before static inet4 addressing -#}
  {%- set link_options =
      ifconfig.get_link_options(interface) | from_json -%}
  {%- if link_options -%}
    {{ segments.append("link " ~ link_options | join(" ")) }}
  {%- endif -%}

  {#- ifconfig inet options must come after link options -#}
  {%- set inet4_options =
      ifconfig.get_inet4_options(interface) | from_json -%}
  {%- if inet4_options -%}
    {{ segments.append("inet " ~ inet4_options | join(" ")) }}
  {%- endif -%}

  {#- ifconfig interface options must come at the very end -#}
  {%- set interface_options =
      ifconfig.get_interface_options(interface) | from_json -%}
  {%- if interface_options -%}
    {{ segments.append(interface_options | join(" ")) }}
  {%- endif -%}

  {#- Render the rc variable line -#}
  {%- set interface_name = common.get_interface_name(interface) -%}
  {%- set rc_var_name = "ifconfig_" ~ interface_name -%}
  {%- set rc_var_value = segments | join(" ") -%}
  {%- if rc_var_value -%}
    {{ format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # render_ifconfig_x_inet6
 #----------------------------------------------------------------------
 #
 # This macro is responsible for generating and echoing the
 # ifconfig_x_inet6 rc variable for the supplied interface.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro render_ifconfig_x_inet6(interface) -%}
  {#- ifconfig segments are stored in this buffer list -#}
  {%- set segments = [] -%}
  {%- set interface_name = common.get_interface_name(interface) -%}

  {#- ifconfig inet6 options -#}
  {%- set inet6_options =
      ifconfig.get_inet6_options(interface) | from_json -%}
  {%- if inet6_options -%}
    {{ segments.append("inet6 " ~ inet6_options | join(" ")) }}
  {%- endif -%}

  {#- Render the rc variable line -#}
  {%- set rc_var_name = "ifconfig_" ~ interface_name ~ '_ipv6' -%}
  {%- set rc_var_value = segments | join(" ") -%}
  {%- if rc_var_value -%}
    {{ format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # render_ifconfig_x_aliases
 #----------------------------------------------------------------------
 #
 # This macro is responsible for generating and echoing the
 # ifconfig_x_aliases rc variable for the supplied interface.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro render_ifconfig_x_aliases(interface) -%}
  {#- ifconfig segments are stored in this buffer list -#}
  {%- set aliases = [] -%}

  {#--------------------------------------------------------------------
   # IPv4 aliases
   #------------------------------------------------------------------#}
  {#- Check whether IPv4 is enabled -#}
  {%- if 'inet4' in interface and 'enabled' in interface['inet4'] -%}
    {%- set inet4_is_enabled = interface['inet4']['enabled'] -%}
  {%- else -%}
    {%- set inet4_is_enabled = false -%}
  {%- endif -%}

  {#- We only process IPv4 aliases when IPv4 is enabled -#}
  {%- if inet4_is_enabled -%}

    {#- Fetch all static IPv4 addresses assigned to this interface -#}
    {%- set inet4_addresses =
          common.get_interface_inet_addresses(
            interface, 'inet4')
          | from_json
    -%}

    {#- We only define aliases when the number of assigned static
     #  addresses is greater than 1 -#}
    {%- if inet4_addresses | length > 1 -%}
      {#- Enumerate aliases -#}
      {%- for inet4_address in inet4_addresses -%}
        {#- Only process aliases; ignore main address -#}
        {%- if loop.index > 1 -%}
          {%- set address =
                ifconfig.format_inet4_address(inet4_address) -%}
          {%- if address -%}
            {{ aliases.append("inet " ~ address) }}
          {%- endif -%}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}

  {%- endif -%}

  {#--------------------------------------------------------------------
   # IPv6 aliases
   #------------------------------------------------------------------#}
  {#- Check whether IPv6 is enabled -#}
  {%- if 'inet6' in interface and 'enabled' in interface['inet6'] -%}
    {%- set inet6_is_enabled = interface['inet6']['enabled'] -%}
  {%- else -%}
    {%- set inet6_is_enabled = false -%}
  {%- endif -%}

  {#- We only process IPv6 aliases when IPv6 is enabled -#}
  {%- if inet6_is_enabled -%}

    {#- Fetch all static IPv6 addresses assigned to this interface -#}
    {%- set inet6_addresses =
          common.get_interface_inet_addresses(
            interface, 'inet6')
          | from_json
    -%}

    {#- We only define aliases when the number of assigned static
     #  addresses is greater than 1 -#}
    {%- if inet6_addresses | length > 1 -%}
      {#- Enumerate aliases -#}
      {%- for inet6_address in inet6_addresses -%}
        {#- Only process aliases; ignore main address -#}
        {%- if loop.index > 1 -%}
          {%- set address =
                ifconfig.format_inet6_address(inet6_address) -%}
          {%- if address -%}
            {{ aliases.append("inet6 " ~ address) }}
          {%- endif -%}
        {%- endif -%}
      {%- endfor -%}
    {%- endif -%}

  {%- endif -%}

  {#--------------------------------------------------------------------
   #  Render the rc variable
   #------------------------------------------------------------------#}
  {%- set interface_name = common.get_interface_name(interface) -%}
  {%- set rc_var_name = "ifconfig_" ~ interface_name ~ '_aliases' -%}
  {%- set rc_var_value = aliases -%}
  {%- if aliases and interface['enabled'] is sameas true -%}
    {{ format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # render_ifconfig_x_descr
 #----------------------------------------------------------------------
 #
 # This macro is responsible for generating and echoing a single
 # ifconfig_x_descr rc variable for the supplied interface. The variable
 # shall only be echoed if the interface includes a description.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro render_ifconfig_x_descr(interface) -%}
  {%- if 'description' in interface -%}
    {%- set interface_name = common.get_interface_name(interface) -%}
    {%- set rc_var_name = "ifconfig_" ~ interface_name ~ "_descr" -%}
    {#- [0:126] => 127 chars + null! -#}
    {%- set rc_var_value = interface['description'][0:126] -%}
    {{ format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # render_ifconfig_x_name
 #----------------------------------------------------------------------
 #
 # This macro is responsible for generating and echoing a single
 # ifconfig_x_name rc variable for the supplied interface. The variable
 # shall only be echoed if the interface is eligible to interface
 # renaming.
 #
 #----------------------------------------------------------------------
 # Parameters
 #----------------------------------------------------------------------
 #  - interface (fr.pep06.schemas.network.interface)
 #      The network interface to process.
 #===================================================================-#}
{%- macro render_ifconfig_x_name(interface) -%}
  {%- set native_name = common.get_interface_name(interface, true) -%}
  {%- set final_name = common.get_interface_name(interface, false)-%}
  {%- if native_name != final_name -%}
    {%- set rc_var_name = "ifconfig_" ~ native_name ~ "_name" -%}
    {%- set rc_var_value = final_name -%}
    {{ format_rc_var(rc_var_name, rc_var_value) }}
  {%- endif -%}
{%- endmacro -%}